# PGM
[![Build Status](https://travis-ci.org/koriavinash1/pgm.svg?branch=master)](https://travis-ci.org/koriavinash1/pgm)
[![Documentation Status](https://readthedocs.org/projects/ppgm/badge/?version=latest)](https://ppgm.readthedocs.io/en/latest/?)
[![PyPI version](https://badge.fury.io/py/ppgm.svg)](https://badge.fury.io/py/ppgm)
[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)

Probabilistic graphs: Representation, Learning, and Inference

## Features

- [x] Representation
  - [x] Bayesian Network Representation
  - [x] Linked List BN Representation
  - [x] Linked List MN Representation
  - [ ] Conditional Estimation
  - [ ] Marginal Estimation
  - [ ] Joint Estimation
- [x] Inference
  - [x] Metropolis-Hastings algorithm
  - [x] Gibbs Sampling on 2d grid
  - [ ] Generalized Gibbs Sampling
  - [x] Message Parsing and BP
  - [x] Loopy BP
  - [x] VE
  - [ ] Causal Interventions
- [x] search methods
  - [x] DFS
  - [x] BFS
- [x] Additional
  - [x] Finding Active Trails
  - [ ] Max clique size and clique node
  - [ ] Calculate tree-width
- [ ] Learning 
- [x] Miscellaneous
  - [x] Random BN and MN generation
 
## Installation
```
pip install ppgm
```
  
## Contact
- Avinash Kori (koriavinash1@gmail.com)
